#pragma once

#ifndef CLASSIC_H
#define CLASSIC_H

#include "AEConfig.h"
#include "entry.h"
#include "AE_Effect.h"
#include "AE_EffectCB.h"
#include "AE_EffectCBSuites.h"
#include "AE_Macros.h"
#include "Param_Utils.h"
#include "Smart_Utils.h"
#include "AEGP_SuiteHandler.h"
#include "AEFX_SuiteHelper.h"

#ifdef AE_OS_WIN
	#include <Windows.h>
#endif

#define	NAME "3DE Classic LD Model"
#define DESCRIPTION	"(c) Science-D-Visions Germany, http://www.sci-d-vis.com"

#define	MAJOR_VERSION		1
#define	MINOR_VERSION		0
#define	BUG_VERSION			0
#define	STAGE_VERSION		PF_Stage_DEVELOP
#define	BUILD_VERSION		1

enum {
	DIST_INPUT = 0,	// default input layer 
	LDP_FOCAL_LENGTH,
	LDP_FB_WIDTH,
	LDP_FB_HEIGHT,
	LDP_FOV_MIN,
	LDP_FOV_MAX,
	LDP_LENS_CENTER_OFFSET_X,
	LDP_LENS_CENTER_OFFSET_Y,
	LDP_PIXEL_ASPECT,
	LDP_DISTORT_MODE,
	LDP_NUM_PARAMS
};

enum {
	FOCAL_LENGTH_ID = 1,
	FB_WIDTH_ID,
	FB_HEIGHT_ID,
	FOV_MIN_ID,
	FOV_MAX_ID,
	LENS_CENTER_OFFSET_X_ID,
	LENS_CENTER_OFFSET_Y_ID,
	PIXEL_ASPECT_ID,
	DISTORT_MODE_ID
};

#define RESTRICT_BOUNDS		0
#define SLIDER_PRECISION	10

#include <ldpk/tde4_ldp_radial_deg_8.h>

enum DISTORTION_MODE {
	DM_DISTORT = 1,
	DM_UNDISTORT
};

typedef struct {
	PF_ProgPtr	ref;
	PF_SampPB	samp_pb;
	PF_InData	in_data;
	PF_Boolean	no_opB;
	tde4_ld_plugin *plugin;
	A_long		footage_width;
	A_long		footage_height;
	DISTORTION_MODE distortion_mode;
	float 		_fov[4];
} DistInfo;

extern "C" {

DllExport	PF_Err 
EntryPointFunc (
	PF_Cmd			cmd,
	PF_InData		*in_data,
	PF_OutData		*out_data,
	PF_ParamDef		*params[],
	PF_LayerDef		*output,
	void			*extraP);

}

#endif // CLASSIC_H